(function(){
	CKEDITOR.plugins.add( 'epebay',{
		afterInit : function(editor){
			var dataProcessor = editor.dataProcessor,
				dataFilter = dataProcessor && dataProcessor.dataFilter;

			if(dataFilter){
				dataFilter.addRules({
					elements: {
						img: function(element){
							var source = element.attributes.src;

							// if img source starts with URL TLEs for image root path
							if(/^#Shop.ProtocolAndServer/.test(source)){
								var FakeElement = editor.createFakeParserElement(element, "ep-EbayFakeImg", "img", false),
									size = source.substr(source.lastIndexOf('#')+1),
									sizeObj = {
										ImageSmall: 'small',
										ImageMedium: 'medium',
										ImageLarge: 'large'
									};

								FakeElement.attributes.title = "ebay placeholder";
								FakeElement.attributes.alt = "ebay placeholder";
								FakeElement.attributes.src = ep.config.iconsRoot + "/preview_img_image" + sizeObj[size] + ".png";
								// FakeElement.attributes.contenteditable = "false";

								return FakeElement;
							}
						}
					}
				});
			}
		}
	});
})();