/*
 * @copyright		© Copyright 2006-2012, epages GmbH, All Rights Reserved.
 *
 * @module			de_epages.externalcontent.ui.cropslidedialog
 *
 * @revision		$$
 */

jQuery.plugin( 'de_epages.externalcontent.gadget.contentslider', {
	plugin:	['de_epages.core', 'jQuery.ui.widget', 'jQuery.cycle']
}, function ($) {
	// Constants.
	var gClassNames = 'Contentslider';

	// The actual widget.
	$.widget('de_epages.externalcontent.gadget.Contentslider', {

		options : {
				'effect' : 'slide',
				'arrows' : false,
				'shadow' : true,
				'border' : 'transparent',
				'automatic' : true,
				'displaytime' : 3
			},

		_create : function () {
			var self = this,
					o = self.options,
					cycleOptions = {};

			switch (o.effect) {
				case 'slide' :
					cycleOptions.fx = 'scrollLeft';
				break;
				case 'blind' :
					cycleOptions.fx = 'blindY';
				break;
				case 'drop' :
					cycleOptions.fx = 'blindX';
				break;
				case 'fade' :
					cycleOptions.fx = 'fade';
				break;
				default:
					cycleOptions.fx = 'fade';
			}

			self.element.addClass(gClassNames);

			self.pager = $('<div>')
				.addClass('contentslider-pager')
				.appendTo(self.element);

			self.list = self.element.children('ul').cycle($.extend(cycleOptions, {
				timeout : o.automatic ? (1000 * o.displaytime) : 0,
				pager : self.pager
			}));


		},

		destroy : function () {
			var self = this;
	 		// Remove all traces of the widget.
	 		self.element.removeClass(gClassNames);
	 		self.list.cycle('destroy');
			self.pager.remove();
			self.Inherited(arguments);
		}

	});

});