/*
 * @copyright   © Copyright 2006-2012, epages GmbH, All Rights Reserved.
 *
 * @module      de_epages.externalcontent.gadget.externalvideo
 *
 * @revision    $$
 */

jQuery.plugin('de_epages.externalcontent.gadget.externalvideo', {
	plugin : ['de_epages.core', 'jQuery.tmpl', 'jQuery.ui.widget']
}, function ($) {

	var gClassNames = '',
			embedIframe = '<iframe width="${width}" height="${height}" src="//${url}${id}" frameborder="0"></iframe>',
			embedObject = '<object name="${id}" id="${id}" type="application/x-shockwave-flash" data="http://sa.kewego.com/swf/p3/epix.swf" width="${width}" height="${height}">'
			+ '<param name="flashVars" value="language_code=fr&playerKey=0df9b773a15b&skinKey=7109c4112f57&sig=${id}&autostart=false&advertise=1" />'
			+ '<param name="movie" value="http://sa.kewego.com/swf/p3/epix.swf" /><param name="allowFullScreen" value="true" />'
			+ '<param name="allowscriptaccess" value="always" /></object>',
			embedEmbed = '<embed flashVars="playerVars=autoPlay=no" src="http://www.metacafe.com/fplayer/${id}.swf"'
			+ 'width="${width}" height="${height}"'
			+ 'wmode="transparent" allowFullScreen="true" allowScriptAccess="always" name="Metacafe"'
			+ 'pluginspage="http://www.macromedia.com/go/getflashplayer" type="application/x-shockwave-flash"></embed>';


	$.widget('de_epages.externalcontent.gadget.Externalvideo', {

		options : {
			provider : "",
			// String. Specifying the provider of the embedded video.
			id : "",
			// String. Specifying a site or id, that consists the video to embed.
			width : 560,
			// String. Specifying the width of the video frame.
			height : 315
			// String. Specifying the height of the video frame.
		},

		_create : function () {
			var self = this,
					o = self.options,
					url,
					template = null;

			if (!o.id || !o.provider) {return self.destroy()}

			switch( o.provider ) {
				case "youtube":
					url = "www.youtube.com/embed/";
					break;
				case "myvideo":
					url = "www.myvideo.de/embed/";
					break;
				case "vimeo":
					url = "player.vimeo.com/video/";
					break;
				case "dailymotion":
					url = "www.dailymotion.com/embed/video/";
					break;
				case "wideofr":
					template = location.protocol == 'http:' ? $.template('de_epages.externalcontent.gadget.wideofr', embedObject) : '';
					break;
				case "metacafe":
					template = location.protocol == 'http:' ? $.template('de_epages.externalcontent.gadget.metacafe', embedEmbed) : '';
					break;
				// default:
			}
			if (template === null) {
				template = $.template('de_epages.externalcontent.gadget.externalvideo', embedIframe);
			}
			self.placeholder = $.tmpl(template, {url:url,id:o.id,width:o.width,height:o.height}).appendTo(self.element.addClass(gClassNames));
		},

		destroy : function () {
			var self = this;
			self.element.removeClass(gClassNames);
			self.placeholder && self.placeholder.remove();
			this.Inherited(arguments);
		}

});

});