/*
 * @copyright		© Copyright 2006-2010, epages GmbH, All Rights Reserved.
 *
 * @module			de_epages.mediagallery.ui.filemanagerdialog
 *
 * @revision		$Revision: 1.1.2.1 $
 */

jQuery.plugin("de_epages.mediagallery.ui.filemanagerdialog", {
	plugin: [
		"jQuery.ui.widget",
		"de_epages.core",
		"ep.ui.dialog",
		"de_epages.mediagallery.ui.filemanager"
	],
	dict : ["de_epages.mediagallery.dictionary"]
}, function($, undefined){

 /*
	*
	* @dictionary			de_epages.mediagallery.dictionary
	*
	* @translation		{FileRepository}
	*
	*/

	// translations
	var mediagalleryDict = $.dict("de_epages.mediagallery.dictionary"),
		tFileRepository =    mediagalleryDict.translate("FileRepository");

	$.widget("de_epages.mediagallery.ui.Filemanagerdialog", {

		options: {
			dialog: {
				title:         tFileRepository,
				width:         920,
				height:        563,
				draggable:     false,
				modal:         true,
				autoOpen:      false
			},
			filemanager: {
				accept:        "*/*",
				selectable:    "",
				currentFolder: "MediaGallery"
			}
		},

		_create: function(){
			var self = this,
				o = self.options;

			self.dialog = ep('<div class="fileManagerDialog"></div>')
				.appendTo("body")
				.uiDialog(o.dialog);

			self.element.on("click.mediagalleryUiFilemanagerdialog", function(){
				self.open();
			});

		},

		open: function(){
			if(!this.filemanager){
				this._createFilemanager();
			}
			ep(this.dialog).uiDialog("open");
		},

		close: function(){
			ep(this.dialog).uiDialog("close");
		},

		destroy: function(){
			if(this.dialog){
				this.dialog.remove();
				this.element.off("click.mediagalleryUiFilemanagerdialog");
			}

			this.Inherited(arguments);
		},

		_createFilemanager: function(){
			var self = this,
					o = this.options;

			self.filemanagerContainer = de_epages('<div class="fileManager"></div>').appendTo(self.dialog);
			self.filemanager = self.filemanagerContainer.mediagalleryUiFilemanager(o.filemanager);

			// trigger event if filemanager is ready
			self.filemanager.on("filemanagerReady", function(){
				self.element.trigger("filemanagerReady");
			});
		},

		resetFilemanager: function(){
			this.filemanager.mediagalleryUiFilemanager("destroy");
			this.filemanager = undefined;
		},

		getCurrentUsage: function(){
			return this.filemanager.mediagalleryUiFilemanager("getCurrentUsage");
		},

		getSelectedElements: function(){
			return this.filemanager.mediagalleryUiFilemanager("getSelectedElements");
		}
	});
});
