jQuery.plugin("de_epages.presentation.inc.filenameinput", ["ep.core", "ep.ui.textedit", "de_epages.core"], function($){

	$.extend( $.scope("de_epages.presentation.inc"), {
		createFileInput: function(options){
			var o = $.extend({
					hiddenInputName: "NewFile",
					selector: ""
				}, options),

				// initialize preview image
				init = function(){

				// make filenames editable
				ep(o.selector).each(function(index, element){
					var epElem = ep(element),               // filename element
						filename = epElem.data('filename'),   // file name (string)
						cell = epElem.closest('td'),          // parent cell
						icon = cell.find('i.Sprite'),         // pencil icon
						hidden = $('<input type="hidden" name="'+o.hiddenInputName+'" value="'+filename+'">');  // hidden input with filename for POST request

					// append hidden input to table cell
					cell.append(hidden);
					// make icon clickable
					icon.on('click', function(){
						epElem.trigger('click');
					});

					// make filename element editable when being clicked
					epElem.uiTextedit({
						stripHTML: true,
						validate:{
							required: true
						},
						onBeforeOpen: function(input){
							input
								.css({'display': 'inline-block'})
								.on('keydown', function(evt){
									// handle enter key to avoid that the form is sumitted unvalidated
									if(evt.keyCode == $.ui.keyCode.ENTER){
										$(this).trigger('blur');
									}
								});
						},
						onAfterOpen: function(input){
							// remove whitespaces from value
							input.val($.trim(input.val()));
						},
						onAfterClose: function(input){
							// set new value to hidden input
							hidden.val(input.val());
						}
					});
				 });

				};

			init();
		}
	});
});